#!/usr/bin/perl

use 5.008;
use strict;
use warnings;

use ExtUtils::MakeMaker;

our %build_reqs = (
	'perl-ExtUtils-Depends'		=> '0.205',
	'perl-ExtUtils-PkgConfig'	=> '1.07',
	'perl-Glib'			=> '1.161',
	'openpgm-2.0'			=> '2.0.18',
);

our %pre_reqs = (
	'ExtUtils::Depends'		=> $build_reqs{'perl-ExtUtils-Depends'},
	'ExtUtils::PkgConfig'		=> $build_reqs{'perl-ExtUtils-PkgConfig'},
	'Glib'				=> $build_reqs{'perl-Glib'},
);

unless (eval "use ExtUtils::Depends '$build_reqs{'perl-ExtUtils-Depends'}';"
           . "use ExtUtils::PkgConfig '$build_reqs{'perl-ExtUtils-PkgConfig'}';"
           . "use Glib '$build_reqs{'perl-Glib'}';"
           . "1") {
	warn "$@\n";
	WriteMakefile(
		PREREQ_FATAL	=> 1,
		PREREQ_PM	=> \%pre_reqs,
	);
	exit 1; # not reached
}

my %pkgcfg;
unless (eval { %pkgcfg = ExtUtils::PkgConfig->find (
		"openpgm-2.0 >= $build_reqs{'openpgm-2.0'}");
		1; })
{
	warn "$@\n";
	exit 1;
}

my $package = new ExtUtils::Depends ('OpenPgm', 'Glib');
$package->set_inc($pkgcfg{cflags});
$package->set_libs($pkgcfg{libs});

# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
WriteMakefile(
	NAME			=> 'OpenPgm',
	VERSION_FROM		=> 'lib/OpenPgm.pm', # finds $VERSION
	PREREQ_PM		=> \%pre_reqs, # e.g., Module::Name => 1.1
	($] >= 5.005 ?     ## Add these new keywords supported since 5.005
		(ABSTRACT_FROM		=> 'lib/OpenPgm.pm', # retrieve abstract from module
		 AUTHOR			=> 'Steven McCoy <steven.mccoy@miru.hk>') : ()),
	LIBS			=> [''], # e.g., '-lm'
	DEFINE			=> '', # e.g., '-DHAVE_SOMETHING'
	INC			=> '-I.', # e.g., '-I. -I/usr/include/other'
	# Un-comment this if you add C files to link with later:
# OBJECT            => '$(O_FILES)', # link all the C files too
	$package->get_makefile_vars()
);

# eof
