#!/usr/bin/perl

use strict;
use warnings;

use Glib qw(TRUE FALSE);
use OpenPgm;

OpenPgm::init() || die "init: $!\n";

my ($network, $res, $gsi, $transport);

$network = "eth0;239.192.0.1";
$res = OpenPgm::Interface::get_transport_info ($network) || die "get_transport_info: $!\n";
$res->{'gsi'} = OpenPgm::Gsi::create_from_hostname () || die "create_from_hostname: $!\n";
$res->{'udp_encap_ucast_port'} = $res->{'dport'};
$res->{'udp_encap_mcast_port'} = $res->{'dport'};
use Data::Dumper; print Dumper $res;
$transport = OpenPgm::Transport::create ($res) || die "create: $!\n";

$transport->set_send_only (TRUE) || die "set_send_only: $!\n";
$transport->set_max_tpdu (1500) || die "set_max_tpdu: $!\n";
$transport->set_txw_sqns (200) || die "set_txw_sqns: $!\n";
$transport->set_txw_max_rte (10 * 1000 * 1000) || die "set_txw_max_rte: $!\n";
$transport->set_multicast_loop (TRUE) || die "set_multicast_loop: $!\n";
$transport->set_hops (16) || die "set_hops: $!\n";
$transport->set_ambient_spm (30 * 1000 * 1000) || die "set_ambient_spm: $!\n";
my $intervals = [ 100 * 1000, 100 * 1000, 100 * 1000, 100 * 1000, 1300 * 1000, 7 * 1000 * 1000, 16 * 1000 * 1000, 25 * 1000 * 1000, 30 * 1000 * 1000 ];
$transport->set_heartbeat_spm ($intervals) || die "set_heartbeat_spm: $!\n";

$transport->bind () || die "bind: $!\n";

$transport->send ("iroiro", 6) || die "send: $!\n";

$transport->destroy (TRUE) || die "destroy: $!\n";

OpenPgm::shutdown() || warn "shutdown: $!\n";
print "finished.\n";

# eof
